using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public class WebForm5 : System.Web.UI.Page
{
	protected System.Web.UI.WebControls.DataGrid DataGrid;

	//	}`EC̃f[^AŎgp邽߂̌^B
	[Serializable]
	public class MyData
	{
		public string f1;
		public string f2;

		public string F1
		{
			get { return this.f1; }
		}

		public string F2
		{
			get { return this.f2; }
		}

		public MyData(string f1, string f2)
		{
			this.f1 = f1;
			this.f2 = f2;
		}
	}

	private void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack)
		{
			//	f[^ViewStateɐݒB
			ViewState["MyDataList"] = new ArrayList(new MyData[] 
				{ new MyData("a", "b"), new MyData("c", "d") });

			//	f[^AwB
			this.DataGrid.DataSource = ViewState["MyDataList"];
			this.DataBind();
		}
	}

	private void DataGrid_EditCommand(
		object source, DataGridCommandEventArgs e)
	{
		//	ҏWΏۍsݒB
		this.DataGrid.EditItemIndex = e.Item.ItemIndex;	

		//	f[^AB
		this.DataGrid.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataGrid_UpdateCommand(
		object source, DataGridCommandEventArgs e)
	{
		//	f[^XVB
		//	͂ꂽĺAZ̒ɂRg[
		//	擾܂B
		ArrayList myDataList = (ArrayList)ViewState["MyDataList"];
		myDataList[e.Item.ItemIndex] = new MyData(
            ((TextBox)e.Item.Cells[0].Controls[0]).Text,
			((TextBox)e.Item.Cells[1].Controls[0]).Text);
		ViewState["MyDataList"] = myDataList;

		//	ҏW[hB
		this.DataGrid.EditItemIndex = -1;

		//	f[^AB
		this.DataGrid.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataGrid_CancelCommand(
		object source, DataGridCommandEventArgs e)
	{
		//	ҏW[hB
		this.DataGrid.EditItemIndex = -1;

		//	f[^AB
		this.DataGrid.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataGrid_DeleteCommand(
		object source, DataGridCommandEventArgs e)
	{
		//	ΏۃR[h폜B
		ArrayList myDataList = (ArrayList)ViewState["MyDataList"];
		myDataList.RemoveAt(e.Item.ItemIndex);
		ViewState["MyDataList"] = myDataList;

		//	ҏW[hB
		this.DataGrid.EditItemIndex = -1;

		//	f[^AB
		this.DataGrid.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	override protected void OnInit(EventArgs e)
	{
		InitializeComponent();
		base.OnInit(e);
	}
	
	private void InitializeComponent()
	{    
		this.Load += new EventHandler(this.Page_Load);
		this.DataGrid.EditCommand += 
			new DataGridCommandEventHandler(this.DataGrid_EditCommand);
		this.DataGrid.UpdateCommand += 
			new DataGridCommandEventHandler(this.DataGrid_UpdateCommand);
		this.DataGrid.CancelCommand += 
			new DataGridCommandEventHandler(this.DataGrid_CancelCommand);
		this.DataGrid.DeleteCommand += 
			new DataGridCommandEventHandler(this.DataGrid_DeleteCommand);
	}
}